<script setup lang="ts">
import {ref, watch, inject, onMounted, onUpdated} from 'vue';
import {createSignatureWithCertificate} from '@/stores/createSignatureWithCertificate';
import {TCertificateIdentifier, TSignCProStrategy, TSignTextContent} from '@/types';
import CertificatesListView from '@/components/CertificatesListView.vue';
import {TCertificatesMap} from '@/provider/BrowserPlugin';
import ProcessignView from '@/components/ProcessignView.vue';
import ErrorView from '@/components/ErrorView.vue';
import {TEdsWidgetCommand, TEdsWidgetEvent, TSize2d} from 'eds-test-pkg-iframe-client';
import {ComponentPublicInstance} from '@vue/runtime-core';
import {CreateSignedDocPresenter, TSignedDocument} from 'edsjs-test-pkg-core'

// todo: надо начать делать презентеры
export type TIAPP = {
  autostart: Boolean;
  unsigned_message: string;
}
// fixme типизировать
const props = defineProps({
  autostart: {
    type: Boolean,
    default: false
  },
  unsigned_message: {
    type: String,
    default: '',
  },
  onSignedMessage: {
    type: String,
    required: false,
  }
});
console.log('direct unsigned message in props is', props.unsigned_message);

const sendEdsPostMessagingEvent = inject('sendEdsPostMessagingEvent') as (e: TEdsWidgetEvent) => void; //fixme
const subscribeToIncomeCommands = inject('subscribeEdsPostMessagingCommands') as (cmd: TEdsWidgetCommand) => void //fixme

function calcHtmlBlockSize(el: ComponentPublicInstance | HTMLElement): TSize2d {
  if ('$el' in el) {
    return {
      width: el.$el.offsetWidth,
      height: el.$el.offsetHeight,
    }
  }
  return {
    width: el.offsetWidth,
    height: el.offsetHeight,
  }
}

function sendEdsSignBlockResized() {
  console.log('UPDATED HTML', edsSignBlockRef.value);
  if (edsSignBlockRef.value) {
    sendEdsPostMessagingEvent({
      name: 'html_updated',
      data: calcHtmlBlockSize(edsSignBlockRef.value),
    })
  }
}
onMounted(() => {
  sendEdsSignBlockResized();
  const {autostart = false, unsigned_message: passed_unsigned_message} = props;
  console.log('ON APP MOUNTED', props, autostart)
  if (autostart) {
    unsigned_message = passed_unsigned_message;
    loadCertificatesList();
  }
});

onUpdated(() => {
  sendEdsSignBlockResized();
})
const edsSignBlockRef = ref<ComponentPublicInstance | null>(null);
const loader = ref(false);
const certificateSelectRequired = ref(false);
const certificatesList = ref<TCertificatesMap>(new Map());

const isProcessing = ref(false);
const processing = ref<{
  message?: string
}>({});

const isError = ref(false);
const error = ref<{
  message?: string
}>({});

let unsigned_message = props?.unsigned_message || '';
let onSignedHandler = props?.onSignedMessage || '';
/// ВНЕШНИЕ
subscribeToIncomeCommands((cmd: TEdsWidgetCommand) => {
  console.info('in', cmd);
  switch (cmd.name) {
    case 'setup': { // fixme trash
      const {content} = cmd.data || {};
      if (content) {
        unsigned_message = content;
      }
      break;
    }
    case 'load_certificates': {
      loadCertificatesList();
      break;
    }
    case 'to_processing': {
      const {message} = cmd.data || {};
      processing.value.message = message;
      isProcessing.value = true;
      certificateSelectRequired.value = false;
    }
  }
});

/// ПО ПРОЦЕССУ
const {
  state,
  sign,
  loadCertificatesList
} = createSignatureWithCertificate();

watch(state, (newState, oldState) => {
  console.log('state', newState, oldState);
  switch (newState.status) {
    case 'processing':
      isProcessing.value = true;
      processing.value.message = newState.processing?.message ?? '';
      isError.value = false;
      certificateSelectRequired.value = false;
      break;
    case 'error':
      isError.value = true;
      if (newState.error) {
        error.value = newState.error;
      }
      isProcessing.value = false;
      certificateSelectRequired.value = false;
      const e: TEdsWidgetEvent = {
        name: 'failed',
        data: {error: newState.error as Error} // fixme
      }
      sendEdsPostMessagingEvent(e);
      break;
    case 'certificate_select':
      isProcessing.value = false;
      isError.value = false;
      certificateSelectRequired.value = true;
      if (newState.certificates) {
        certificatesList.value = newState.certificates;
      }
      break;
    case 'done':
      if (onSignedHandler) {
        const presenter = new CreateSignedDocPresenter();
        presenter.view = {
          onCreateSignedDocDone(document: TSignedDocument): void {
            isProcessing.value = false;
            isError.value = false;
            certificateSelectRequired.value = false;
            const ev: TEdsWidgetEvent = {
              name: 'doc_created',
              data: {doc_id: document.doc_id} //fixme
            }
            sendEdsPostMessagingEvent(ev);
          }, onCreateSignedDocError(e: Error): void {
            isProcessing.value = false;
            isError.value = true;
            error.value.message = e.message;
            console.log(error);
          }, onCreateSignedDocPending(pending_message: string | undefined): void {
            isProcessing.value = true;
            processing.value.message = pending_message;
            isError.value = false;
            certificateSelectRequired.value = false;
          }
        };
        presenter.create(newState.signature as string, unsigned_message);
      } else {
        isProcessing.value = false;
        isError.value = false;
        certificateSelectRequired.value = false;
        const ev: TEdsWidgetEvent = {
          name: 'signed',
          data: {signature: newState.signature as string} //fixme
        }
        sendEdsPostMessagingEvent(ev);
      }
      break;
    case 'idle':
    default:
      isProcessing.value = false;
      certificateSelectRequired.value = false;
  }
});

const createSignature = (certificate: TCertificateIdentifier) => {
  const ctx = { // fixme контекст вообще не нужен тут
    content: {type: 'text', unsigned_message: unsigned_message.length ? unsigned_message : 'Some test string'} as TSignTextContent,
    strategy: {type: 'qualified', software: 'cpro', certificate_identifier: 'ABCDE'} as TSignCProStrategy
  };
  sign(ctx, certificate);
}

const slotModal = ref(false);
const modal = ref(false);
</script>

<template>
  <div ref="edsSignBlockRef">
    <CdsButton v-if="state.status === 'idle'" @click="loadCertificatesList">Manual load</CdsButton>
    <CertificatesListView v-if="certificateSelectRequired" v-model="certificatesList" @confirmed="createSignature"/>
    <ErrorView v-if="isError" v-model="error"/>
    <ProcessignView v-if="isProcessing" v-model="processing"/>
  </div>
  <!--  <CdsLoader v-show="loader"/>-->
</template>
